import random
import string
from tqdm import tqdm
import time
from colorama import Fore, Style, init

init(autoreset=True)

def generate_password(length=8):
    if length < 6 or length > 8:
        raise ValueError("Length must be between 6 and 8 characters.")

    all_characters = string.ascii_letters + string.digits + "@#&*"
    password = [
        random.choice(string.ascii_lowercase),  # לפחות אות קטנה אחת
        random.choice(string.ascii_uppercase),  # לפחות אות גדולה אחת
        random.choice(string.digits),           # לפחות מספר אחד
        random.choice("@#&*")                   # לפחות תו מיוחד אחד
    ]

    while len(password) < length:
        password.append(random.choice(all_characters))

    random.shuffle(password)
    return ''.join(password)

def display_password_with_loading(password):
    print(Fore.CYAN + Style.BRIGHT + "\nWelcome to Password Generator\n")
    print(Fore.GREEN + "Generating your password:")
    for _ in tqdm(range(10), desc=Fore.YELLOW + "Progress", ncols=100, ascii=True):
        time.sleep(0.1)  # פס טעינה
    print(Fore.GREEN + "\nYour generated password is: " + Fore.RED + password + "\n")

# יצירת הסיסמה
password = generate_password()
display_password_with_loading(password)
